package org.nuiton.topiatest.deletetest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class Telephone2DAOAbstract<E extends Telephone2> extends Contact2DAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)Telephone2.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.Telephone2;
    }

    public E findByPrefix(String v) throws TopiaException {
        E result = findByProperty(Telephone2.PROPERTY_PREFIX, v);
        return result;
    }

    public List<E> findAllByPrefix(String v) throws TopiaException {
        List<E> result = findAllByProperty(Telephone2.PROPERTY_PREFIX, v);
        return result;
    }

    public E findByCountry(String v) throws TopiaException {
        E result = findByProperty(Telephone2.PROPERTY_COUNTRY, v);
        return result;
    }

    public List<E> findAllByCountry(String v) throws TopiaException {
        List<E> result = findAllByProperty(Telephone2.PROPERTY_COUNTRY, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //Telephone2DAOAbstract<E extends Telephone2>
